2023-02-13 17:22:41 +08:00
#!/bin/bash
2023-02-13 17:23:44 +08:00
#from https://github.com/spiritLHLS/pve
2023-02-13 18:20:44 +08:00
# pve 7
2023-02-13 17:23:44 +08:00
2023-02-13 18:27:13 +08:00
# 前置环境安装
2023-02-13 17:22:41 +08:00
if [ " $( id -u) " != "0" ] ; then
echo "This script must be run as root" 1>& 2
exit 1
fi
2023-02-13 17:30:33 +08:00
if ! command -v wget > /dev/null 2>& 1; then
apt-get install -y wget
fi
2023-02-13 17:59:35 +08:00
if ! command -v curl > /dev/null 2>& 1; then
apt-get install -y curl
fi
2023-02-13 18:52:59 +08:00
# if ! command -v ufw > /dev/null 2>&1; then
# apt-get install -y ufw
# fi
# ufw disable
2023-02-13 18:25:04 +08:00
apt-get install gnupg -y
2023-02-13 18:52:59 +08:00
if ! nc -z localhost 7789; then
iptables -A INPUT -p tcp --dport 7789 -j ACCEPT
iptables-save > /etc/iptables.rules
fi
2023-02-13 19:02:10 +08:00
if [ $( uname -m) != "x86_64" ] || [ ! -f /etc/debian_version ] || [ $( grep MemTotal /proc/meminfo | awk '{print $2}' ) -lt 2000000 ] || [ $( grep -c ^processor /proc/cpuinfo) -lt 2 ] || [ $( ping -c 3 google.com > /dev/null 2>& 1; echo $? ) -ne 0 ] ; then
echo "Error: This system does not meet the minimum requirements for Proxmox VE installation."
exit 1
else
echo "The system meets the minimum requirements for Proxmox VE installation."
fi
2023-02-13 17:59:35 +08:00
2023-02-13 18:27:13 +08:00
# 修改 /etc/hosts
2023-02-13 18:02:29 +08:00
ip = $( curl -s ipv4.ip.sb)
2023-02-13 18:20:26 +08:00
line_number = $( tac /etc/hosts | grep -n "^127\.0\.0\.1" | head -n 1 | awk -F: '{print $1}' )
2023-02-13 19:26:28 +08:00
# echo "$ip pve.proxmox.com pve" | tee -a /etc/hosts > /dev/null
2023-02-13 18:20:26 +08:00
sed -i " ${ line_number } a $ip pve.proxmox.com pve " /etc/hosts
2023-02-13 17:59:35 +08:00
2023-02-13 18:27:13 +08:00
# 新增pve源
2023-02-13 17:52:49 +08:00
version = $( lsb_release -cs)
if [ " $version " = = "jessie" ] ; then
repo_url = "deb https://mirrors.tuna.tsinghua.edu.cn/proxmox/debian/pve jessie pve-no-subscription"
elif [ " $version " = = "stretch" ] ; then
repo_url = "deb https://mirrors.tuna.tsinghua.edu.cn/proxmox/debian/pve stretch pve-no-subscription"
elif [ " $version " = = "buster" ] ; then
repo_url = "deb https://mirrors.tuna.tsinghua.edu.cn/proxmox/debian/pve buster pve-no-subscription"
2023-02-13 18:20:26 +08:00
wget https://github.com/spiritLHLS/pve/raw/main/gpg/proxmox-release-buster.gpg -O /etc/apt/trusted.gpg.d/proxmox-release-buster.gpg
apt-key add /etc/apt/trusted.gpg.d/proxmox-release-buster.gpg
2023-02-13 17:52:49 +08:00
elif [ " $version " = = "bullseye" ] ; then
repo_url = "deb https://mirrors.tuna.tsinghua.edu.cn/proxmox/debian/pve bullseye pve-no-subscription"
wget http://download.proxmox.com/debian/proxmox-release-bullseye.gpg -O /etc/apt/trusted.gpg.d/proxmox-release-bullseye.gpg
apt-key add /etc/apt/trusted.gpg.d/proxmox-release-bullseye.gpg
else
echo "Error: Unsupported Debian version"
exit 1
fi
echo " $repo_url " >> /etc/apt/sources.list
2023-02-13 17:59:35 +08:00
2023-02-13 18:27:13 +08:00
# 下载pve
2023-02-13 18:20:26 +08:00
apt-get update && apt-get full-upgrade
2023-02-13 18:56:00 +08:00
if [ $? -ne 0 ] ; then
apt-get install debian-keyring debian-archive-keyring -y
apt-get update && apt-get full-upgrade
fi
2023-02-13 19:02:10 +08:00
apt-get -y install postfix open-iscsi
apt-get -y install proxmox-ve
2023-02-13 17:38:03 +08:00
2023-02-13 18:40:42 +08:00
# 检查pve
result = $( journalctl -xe | grep "/etc/pve/local/pve-ssl.key: failed to load local private key (key_file or key) at /usr/share/perl5/PVE/APIServer/AnyEvent.pm line" )
if [ -n " $result " ] ; then
pvecm createcert
systemctl restart pve-manager
fi